' vcslncnv.vbs
' VC++̃\[Vt@CƂňvWFNgt@C
' Abv/_EO[h(.NETȍ~)
' @author AmaiSaeta.
' @copyright (C) 2006 AmaiSaeta.

Option Explicit
' Version Number
Const version = "1.11.20061023"

' 
Const envName = "Visual C++ Express"

' IDEID
Const id2002 = 0	' .NET (2002)
Const id2003 = 1	' .NET 2003
Const id2005 = 2	' 2005
Const idNum  = 3	' idXXX̐

' MEMO: e@[W; Ή𑝂₷͕Kzvf𑝂₷!
' ̂̃o[W
Dim envVersion(3)
envVersion(id2002) = "7.00"	' .NET (2002)
envVersion(id2003) = "7.10"	' .NET 2003
envVersion(id2005) = "8.00"	' 2005

' slno[W
Dim slnVersion(3)
slnVersion(id2002) = "7.00"	' .NET (2002)
slnVersion(id2003) = "8.00"	' .NET 2003
slnVersion(id2005) = "9.00"	' 2005

' vcprojo[W
Dim projVersion(3)
projVersion(id2002) = "7.00"	' .NET (2002)
projVersion(id2003) = "7.10"	' .NET 2003
projVersion(id2005) = "8.00"	' 2005

' FileSystemObject
Dim fso
Set fso = CreateObject("Scripting.FileSystemObject")

' 葽̕ϊo͂邩ǂ
Dim talkative
If WScript.Arguments.Count = 3 Then
	if LCase(WScript.Arguments.Item(2)) = "/t" Then
		talkative = True
	End If
End If

' IvVw莞\tg\
If WScript.Arguments.Count < 2 Then
	printInfo
	WScript.Quit
End If

Dim slnFromFilePath	' ϊslnpX
slnFromFilePath = WScript.Arguments(0)
Dim hittingEnvVersion	' T|[go[Wƈvǂ
hittingEnvVersion = False
Dim i	' [vJE^
Dim slnToId	' ϊslno[WID
For i = 0 To idNum
	If CSng(envVersion(i)) = CSng(WScript.Arguments(1)) Then
		slnToId = i
		hittingEnvVersion = True
		Exit For
	End If
Next
If Not hittingEnvVersion Then
	printInfo
	WScript.Quit
End If

' \[Vt@C݊mF; ΃G[óAI
If Not fso.FileExists(slnFromFilePath) Then
	WScript.Echo "File not found: " & slnFromFilePath
	WScript.Quit
End If
Dim slnFromFileDirPath	' slnfBNgpX
slnFromFileDirPath _
	= fso.GetParentFolderName(fso.GetAbsolutePathName(slnFromFilePath))

	WScript.Echo "Input sln found in: " & slnFromFileDirPath

Dim slnFromFileStream	' ϊslnt@C
Set slnFromFileStream = fso.OpenTextFile(slnFromFilePath, 1, false, -2)

' 1s(Ao[W)ǂݍ
Dim text	' slne
Dim ver	' slno[W
Dim regexp ' RegExp
Set regexp = New RegExp
regexp.Pattern = "^([\w ,]+)(\d+\.\d+)$"
' sUTF-8 BOMXLbvׂDo~Loopŉ
Dim matchedSlnVersionLine
matchedSlnVersionLine = False
Do
text = slnFromFileStream.ReadLine
	Dim matches	' RegExp}b`
	Set matches = regexp.Execute(text)
	If matches.Count = 1 Then
		text = matches(0).SubMatches(0)
		ver = matches(0).SubMatches(1)

		printIfTalkative "Input sln version text  : " & text
		printIfTalkative "Input sln version number: " & ver

		Dim slnFromId	' o[WID
		For i = 0 To idNum - 1
			If CSng(ver) = CSng(slnVersion(i)) Then
				slnFromId = i

				printIfTalkative "Input sln version id: " & i

				Exit For
			End If
		Next

		matchedSlnVersionLine = True
		Exit Do
	End If
Loop Until slnFromFileStream.AtEndOfStream
' slnŏ̍sȂ
If Not matchedSlnVersionLine Then
	WScript.Echo "This file is not supported."
	WScript.Quit
End If

Dim slnToFilePath	' o͐t@CpX
slnToFilePath = getOutputFilePath( _
	slnFromFilePath, envVersion(slnFromId), envVersion(slnToId))

WScript.Echo "Output sln name: " & slnToFilePath

' Rs[Jn
Dim slnToFile	' slnRs[t@C
Set slnToFile = fso.OpenTextFile(slnToFilePath, 2, true)
slnToFile.WriteLine(text & slnVersion(slnToId))

' slnt@C擾 (for 2005)
' R2005ł͐slnƔFȂB
If slnFromId <> id2005 And slnToId = id2005 Then
	slnToFile.WriteLine("# " & envName & " 2005")
ElseIf slnFromId = id2005 And slnToId <> id2005 Then
	' 20052005ȊO̕ϊ̍ۂ2005ł鎖Rgs폜
	regexp.Pattern = "^#[ \t]*" & envName & "[ \t]*2005"
	Dim dummy
	dummy = slnFromFileStream.ReadLine	' 킴1sǂݍ݁ÂĂ 
End If


' slnRs[
While Not slnFromFileStream.AtEndOfStream
	text = slnFromFileStream.ReadLine

	Dim projFromFilePath	' vcprojt@CpX
	Dim projToFilePath	' vcprojϊt@CpX

	' vcprojo^T
	regexp.Pattern = "^Project\("
	If regexp.Test(text) Then
		slnToFile.write "Project("
		regexp.Pattern = "\""([^\""]*)\"""
		regexp.Global = True
		Set matches = regexp.Execute(text)
		projFromFilePath = matches(2).SubMatches(0)
		WScript.Echo "Input vcproj found: " & projFromFilePath
		projToFilePath = getOutputFilePath( _
			projFromFilePath, projVersion(slnFromId), projVersion(slnToId))
		WScript.Echo "Output vcproj name: " & projToFilePath

		' vcprojo^
		slnToFile.Write matches(0).Value & ") = "
		slnToFile.Write matches(1).Value & ", "
		slnToFile.Write """" & projToFilePath & """, "
		slnToFile.WriteLine matches(3).Value

		convertProj fso.BuildPath(slnFromFileDirPath, projFromFilePath), _
			fso.BuildPath(slnFromFileDirPath, projToFilePath), slnToId
	Else
		slnToFile.WriteLine text
	End If
Wend

WScript.Echo "done."	' I



' ===============================================
' sub

' \tg̕\
Sub printInfo
	WScript.Echo _
		"vcslncnv.vbs (version: " & version & ")" & vbNewLine _
		& vbTab & ": Converts a VC++'s solution to an other VC++'s solution." _
		& vbNewLine _
		& vbNewLine _
		& "This program support VC++ versions are..." & vbNewLine _
		& vbTab & "7.0  (Visual C++ .NET)" & vbNewLine _
		& vbTab & "7.1  (Visual C++ .NET 2003)" & vbNewLine _
		& vbTab & "8.0  (Visual C++ 2005)" & vbNewLine _
		& vbNewLine _
		& "Usage: vcslncnv.vbs [SOLUTIONFILEPATH CONVERTVERSION /T]" _
		& vbNewLine _
		& vbTab & "SOLUTIONFILEPATH  Sorce solution file path." & vbNewLine _
		& vbTab & "CONVERTVERSION    Dest VC++ version." & vbNewLine _
		& vbTab & "/T                Print more information.(TALKATIVE MODE)" _
		& vbNewLine _
		& vbNewLine _
		& "example:" & vbNewLine _
		& vbTab & "cscript vcslncnv.vbs foo.sln 7.10" & vbNewLine _
		& vbTab & vbTab _
		& "foo.sln and its projects convert to VC++ .NET 2003 version." _
		& vbNewLine _
		& vbTab & vbTab _
		& "Convert file names add ""_7.10"" sufix." & vbNewLine _
		& vbTab & vbTab & vbTab & "-> foo_7.10.sln" & vbNewLine _
		& vbTab & "cscript vcslncnv.vbs bar_7.00 8.00" & vbNewLine _
		& vbTab & vbTab _
		& "bar_7.00.sln and its projects convert to VC++ 2005 version."_
		& vbNewLine _
		& vbTab & vbTab _
		& "Convert file names change sufix to ""_8.00""." & vbNewLine _
		& vbTab & vbTab & vbTab & "-> bar_8.00.sln" & vbNewLine _
		& vbNewLine _
		& "Copyright(C) 2006 AmaiSaeta."
End Sub

' vcprojt@Cϊ
' @param[in]	projFromFile	ϊt@CpX
' @param[in]	projToFile		ϊt@CpX
' @param[in]	idProj			ϊ̃@[W
Sub convertProj(projFromFile, projToFile, idProj)
	printIfTalkative "in Sub convertProj(" _
		& projFromFile & ", " & projToFile & ", " & idProj & ")"

	Dim projFromFileStream	' vcprojt@CXg[
	Dim projToFileStream	' vcprojϊt@CXg[
	Set projFromFileStream = fso.OpenTextFile(projFromFile, 1)
	Set projToFileStream = fso.OpenTextFile(projToFile, 2, True)

	Dim text
	Dim regexp
	Set regexp = New RegExp
	Dim processingProjInElement	' vcprojVisualStudioProject
	processingProjInElement = False

	While Not projFromFileStream.AtEndOfStream
		text = projFromFileStream.ReadLine

		If Not processingProjInElement Then
			' VisualStudioProjectvfT
			regexp.Pattern = "<VisualStudioProject"
			If regexp.Test(text) Then

				printIfTalkative "Found VisualStudioProject elem."
				processingProjInElement = True
			End If
		End If
		If processingProjInElement Then	' VisualStudioProjectvfJn^O
			' Version̒T
			regexp.Pattern = "(.*)Version="".*""(.*)"
			Dim matches
			Set matches = regexp.Execute(text)
			If matches.Count = 1 Then
				Dim before, after
				before = matches(0).SubMatches(0)
				after = matches(0).Submatches(1)

				printIfTalkative "Input vcproj version: " & projversion(idProj)

				text = before&"Version="""&projversion(idProj)&""""&after
			End If
			regexp.Pattern = ">"
			If regexp.Test(text) Then processingProjInElement = False
		End If

		ProjToFileStream.WriteLine text
	Wend

	projFromFileStream.Close
	projToFileStream.Close
End Sub

' 葽̏o͂.
' O[oϐtalkativeTrue̎̂ݎw肵Cӕo͂B
' @param[in]	string	o͕
Sub printIfTalkative(string)
	If Not talkative Then Exit Sub

	WScript.Echo string
End Sub


' ===============================================
' function

' o͐t@CpX̎擾.
' ͌t@CƏo͐t@Co[WAOŐ.
' A͌t@C̖̃t@Co[W̏ꍇ͂폜
' ŏo͐t@Co[WƘAB
' ֌W̓t@CɕtĂꍇ͏o͐t@Co[W
' AO'_'
' ex)
' 	: "hoge.sln", 7.0 8.0
' 		 hoge8.sln
' 	: "hoge7.00.sln", 7.0 8.0
' 		 hoge8.sln
' 	: "hoge7.1.sln", 7.0 8.0
' 		 hoge7.1_8.sln
' @param[in]	inFilePath	͌t@CpX
' @param[in]	inFileVer	͌t@Co[W
' @param[in]	outFileVer	o͐t@Co[W
' @return	o͐t@CpX
Function getOutputFilePath(inFilePath, inFileVer, outFileVer)
	printIfTalkative "in Function getOutputFilePath(" _
		& inFilePath & ", " & inFileVer & ", " & outFileVer & ")"

	Dim regexp
	Set regexp = New RegExp

	' ͌t@Ct@Cƃo[W\L(filename00.00)
	' To
	regexp.Pattern="([^\\/:\*\?""<>\|]*[^(\d+(\.\d+)?)?])(\d+(\.\d+)?)?$"
	Dim matches
	Set matches = regexp.Execute(fso.GetBaseName(inFilePath))
	Dim filename, version, fileDirPath, fileExt
	filename  = matches(0).SubMatches(0)
	version   = matches(0).SubMatches(1)
	fileDirPath = fso.GetParentFolderName(inFilePath)
	fileExt = fso.GetExtensionName(inFilePath)

	printIfTalkative "File-name part in input file-name: " & filename
	printIfTalkative "Version   part in input file-name: " & version
	printIfTalkative "Directory-path in input file-name: " & fileDirPath
	printIfTalkative "file-ext  part in input file-name: " & fileExt
	printIftalkative "Version        in input file     : " & inFileVer

	' o[W\LƎۂ̃o[WrA
	' 	Ȃ	t@CAo͐o[W
	'	ʂȂ	t@CAo[W\LAo͐o[W
	' ɘAo͐t@Cɂ
	Dim outFileName	' o̓t@C

	If CSng(version) = CSng(inFileVer) Then
		outFileName = filename  & outFileVer
	Else
		regexp.Pattern = "[0-9]$"
		If regexp.Test(version) Then
			' ̓t@C̍Ō(̓t@Co[WƎvĂ)
			' ̏ꍇ"_"ŋ؂
			outFileName = filename & version & "_" & outFileVer
		Else
			outFileName = filename & version & outFileVer
		End If
	End If

	' return value
	getOutputFilePath = fso.BuildPath(fileDirPath, outFileName & "." & fileExt)

	printIfTalkative "Output file path: " & getOutputFilePath
End Function

' @file
' @par XV
' 	+1.00.20060607
' 		+.
' 	+1.10.20061020
' 		+slnt@C擪̋sBOMɑΉ.
' 		+Debugp\/TIvVƂĎȂ.
' 	+1.11.20061023
' 		+2005Express2005ւ̕ϊVC++2005ExpresspRg
' 		 폜悤ύX.ɂA2005Express20052005Express
' 		 ϊɔRg1BoOɑΏ.
' 		+XVt@CɈړ.
' 		+wveύX.
' 			+@[Wԍ\悤.
' 			+`bg`.
' 			+@I()𒼂.

